source: common/libs/func_validate_configs.sh@ f32cd50

ablfs-more trunk
Last change on this file since f32cd50 was 9b99ada, checked in by Pierre Labastie <pierre.labastie@…>, 3 years ago

Change variable names and logic for BLFS book

Only use BLFS_COMMIT instead of BLFS_BRANCH_ID, BLFS_TREE, BLFS_BOOK
Same for le LFS_BLFS variables

  • Property mode set to 100644
File size: 9.7 KB
RevLine 
[c14e4b3]1declare -r dotSTR=".................."
2
[877cc6a]3
4#----------------------------#
[45f82718]5validate_config() { # Are the config values sane (within reason)
[877cc6a]6#----------------------------#
7: <<inline_doc
[8825e69]8 Validates the configuration parameters.
[877cc6a]9
10 input vars: none
11 externals: color constants
12 modifies: none
13 returns: nothing
[45f82718]14 on error: write text to console and dies
[877cc6a]15 on success: write text to console and returns
16inline_doc
17
[350625a]18 # Common settings by Config.in sections and books family
[8825e69]19 local -r BOOK_common="COMMIT BOOK CUSTOM_TOOLS"
[350625a]20 local -r GENERAL_common="LUSER LGROUP LHOME BUILDDIR CLEAN GETPKG SRC_ARCHIVE \
[de63126]21 SERVER RETRYSRCDOWNLOAD RETRYDOWNLOADCNT DOWNLOADTIMEOUT \
[3158dfa]22 RUNMAKE"
[350625a]23 local -r BUILD_chroot="TEST BOMB_TEST STRIP"
[f546320]24 local -r BUILD_common="FSTAB CONFIG TIMEZONE PAGE LANG INSTALL_LOG"
[f596dde]25 local -r ADVANCED_chroot="COMPARE RUN_ICA ITERATIONS OPTIMIZE"
[350625a]26 local -r ADVANCED_common="REPORT REBUILD_MAKEFILE"
27
28 # BOOK Settings by book
[878a5a0]29 local -r LFS_book="$BOOK_common INITSYS BLFS_TOOL"
[350625a]30
31 # Build Settings by book
[085435e]32 local -r LFS_build="$BUILD_chroot NCURSES5 DEL_LA_FILES $BUILD_common PKGMNGT FULL_LOCALE WRAP_INSTALL"
[350625a]33
[0fa52f2]34 # System Settings by book
[3b43e17b]35 local -r LFS_system="HOSTNAME INTERFACE IP_ADDR GATEWAY PREFIX BROADCAST DOMAIN DNS1 DNS2 FONT KEYMAP LOCAL LOG_LEVEL"
[945ccaa]36
[350625a]37 # Full list of books settings
[52cced4]38 local -r lfs_PARAM_LIST="$LFS_book $GENERAL_common $LFS_build $LFS_system $ADVANCED_chroot N_PARALLEL REALSBU SAVE_CH5 $ADVANCED_common"
[854854e]39# local -r blfs_PARAM_LIST="BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR"
[877cc6a]40
[854854e]41 # Additional variables
42 local -r blfs_tool_PARAM_LIST="\
[9b99ada]43 BLFS_COMMIT BLFS_ROOT BLFS_XML TRACKING_DIR \
[f1fcb6b]44 DEP_LIBXML DEP_LIBXSLT DEP_DBXML DEP_LYNX DEP_SUDO DEP_WGET \
[dfab075]45 DEP_GIT DEP_GPM"
[53f291f]46 local -r custom_tool_PARAM_LIST="TRACKING_DIR"
[4965fa8]47
[350625a]48 # Internal variables
[877cc6a]49 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
[4965fa8]50 local -r ERROR_MSG_pt2='rerun make and fix your configuration settings${OFF}'
[c14e4b3]51 local -r PARAM_VALS='${config_param}${dotSTR:${#config_param}} ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
[877cc6a]52
[3e7ceed]53 local PARAM_LIST=
[877cc6a]54 local config_param
55 local validation_str
[45f82718]56 local save_param
[877cc6a]57
58 write_error_and_die() {
59 echo -e "\n${DD_BORDER}"
60 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
61 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
62 echo -e "${DD_BORDER}\n"
63 exit 1
64 }
65
[3aa1acd]66# This function is only used when testing package management files.
67 write_pkg_and_die() {
68 echo -e "\n${DD_BORDER}"
69 echo "Package management is requested but" >&2
70 echo -e $* >&2
71 echo -e "${DD_BORDER}\n"
72 exit 1
73 }
74
[45f82718]75 validate_file() {
76 # For parameters ending with a '+' failure causes a warning message only
77 echo -n "`eval echo $PARAM_VALS`"
78 while test $# -gt 0 ; do
79 case $1 in
80 # Failures caused program exit
81 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO file name given" && write_error_and_die ;;
82 "-e") [[ ! -e "${!config_param}" ]] && echo "${tab_}<-- file does not exist" && write_error_and_die ;;
83 "-s") [[ ! -s "${!config_param}" ]] && echo "${tab_}<-- file has zero bytes" && write_error_and_die ;;
84 "-r") [[ ! -r "${!config_param}" ]] && echo "${tab_}<-- no read permission " && write_error_and_die ;;
85 "-w") [[ ! -w "${!config_param}" ]] && echo "${tab_}<-- no write permission" && write_error_and_die ;;
86 "-x") [[ ! -x "${!config_param}" ]] && echo "${tab_}<-- file cannot be executed" && write_error_and_die ;;
87 # Warning messages only
88 "-z+") [[ -z "${!config_param}" ]] && echo && return ;;
89 esac
90 shift 1
91 done
92 echo
93 }
94
95 validate_dir() {
96 # For parameters ending with a '+' failure causes a warning message only
97 echo -n "`eval echo $PARAM_VALS`"
98 while test $# -gt 0 ; do
99 case $1 in
100 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}NO directory name given" && write_error_and_die ;;
101 "-d") [[ ! -d "${!config_param}" ]] && echo "${tab_}This is NOT a directory" && write_error_and_die ;;
102 "-w") if [[ ! -w "${!config_param}" ]]; then
103 echo "${nl_}${DD_BORDER}"
104 echo "${tab_}${RED}You do not have ${L_arrow}write${R_arrow}${RED} access to the directory${OFF}"
105 echo "${tab_}${BOLD}${!config_param}${OFF}"
106 echo "${DD_BORDER}${nl_}"
107 exit 1
108 fi ;;
109 # Warnings only
110 "-w+") if [[ ! -w "${!config_param}" ]]; then
111 echo "${nl_}${DD_BORDER}"
112 echo "${tab_}WARNING-- You do not have ${L_arrow}write${R_arrow} access to the directory${OFF}"
113 echo "${tab_} -- ${BOLD}${!config_param}${OFF}"
114 echo "${DD_BORDER}"
115 fi ;;
116 "-z+") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO directory name given" && return
117 esac
118 shift 1
119 done
120 echo
121 }
122
[877cc6a]123 set +e
[8825e69]124 for config_param in $lfs_PARAM_LIST; do
[45f82718]125 case $config_param in
[4da2512]126 # Envvars that depend on other settings to be displayed
[de63126]127 COMPARE) [[ ! "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
128 RUN_ICA) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
129 ITERATIONS) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
130 BOMB_TEST) [[ ! "$TEST" = "0" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
131 TARGET32) [[ -n "${TARGET32}" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
132 MIPS_LEVEL) [[ "${ARCH}" = "mips" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
133 SERVER) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
134 RETRYSRCDOWNLOAD) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
135 RETRYDOWNLOADCNT) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
136 DOWNLOADTIMEOUT) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
[52cced4]137 N_PARALLEL) [[ "$OPTIMIZE" -gt "0" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
[84a3fda]138 REALSBU) [[ "$OPTIMIZE" = "2" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
[4da2512]139
140 # Envars that requires some validation
141 LUSER) echo -e "`eval echo $PARAM_VALS`"
142 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
143 ;;
144 LGROUP) echo -e "`eval echo $PARAM_VALS`"
145 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
146 ;;
147 # BOOK validation. Very ugly, need be fixed
[4965fa8]148 BOOK) if [[ "${WORKING_COPY}" = "y" ]] ; then
[45f82718]149 validate_dir -z -d
150 else
[4da2512]151 echo -e "`eval echo $PARAM_VALS`"
[0210014]152 fi
153 ;;
[4da2512]154 # Validate directories, testable states:
155 # fatal -z -d -w,
156 # warning -z+ -w+
[401f81e]157 SRC_ARCHIVE) [[ "$GETPKG" = "y" ]] && validate_dir -z+ -d -w+ ;;
[4da2512]158 # The build directory/partition MUST exist and be writable by the user
[c7b535b]159 BUILDDIR) validate_dir -z -d
[a96109a]160 [[ "xx x/x" =~ x${!config_param}x ]] && write_error_and_die ;;
[962793a]161 LHOME) validate_dir -z -d ;;
[45f82718]162
[4da2512]163 # Validate files, testable states:
164 # fatal -z -e -s -w -x -r,
165 # warning -z+
[45f82718]166 FSTAB) validate_file -z+ -e -s ;;
167 CONFIG) validate_file -z+ -e -s ;;
168 BOOT_CONFIG) [[ "${METHOD}" = "boot" ]] && validate_file -z -e -s ;;
169
[5c575e1]170 # Treatment of LANG parameter
171 LANG ) # See it the locale value has been set
[45f82718]172 echo -n "`eval echo $PARAM_VALS`"
173 [[ -z "${!config_param}" ]] &&
174 echo " -- Variable $config_param cannot be empty!" &&
175 write_error_and_die
176 echo
177 ;;
[c59f9a0]178
[945ccaa]179 # Treatment of HOSTNAME
180 HOSTNAME) echo -e "`eval echo $PARAM_VALS`"
181 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
182 ;;
183
[3aa1acd]184 # Case of PKGMNGT: two files, packageManager.xml and packInstall.sh
[c67990f]185 # must exist in $PKGMNGTDIR if PKGMNGT='y':
[3aa1acd]186 PKGMNGT) echo -e "`eval echo $PARAM_VALS`"
[c67990f]187 if [ "$PKGMNGT" = y ]; then
188 if [ ! -e "$PKGMNGTDIR/packageManager.xml" ]; then
189 write_pkg_and_die $PKGMNGTDIR/packageManager.xml does not exist
190 fi
191 if [ ! -e "$PKGMNGTDIR/packInstall.sh" ]; then
192 write_pkg_and_die $PKGMNGTDIR/packInstall.sh does not exist
193 fi
194 if [ ! -s "$PKGMNGTDIR/packageManager.xml" ]; then
195 write_pkg_and_die $PKGMNGTDIR/packageManager.xml has zero size
196 fi
197 if [ ! -s "$PKGMNGTDIR/packInstall.sh" ]; then
198 write_pkg_and_die $PKGMNGTDIR/packInstall.sh has zero size
199 fi
200 if [ ! -r "$PKGMNGTDIR/packageManager.xml" ]; then
201 write_pkg_and_die $PKGMNGTDIR/packageManager.xml is not readable
202 fi
203 if [ ! -r "$PKGMNGTDIR/packInstall.sh" ]; then
204 write_pkg_and_die $PKGMNGTDIR/packInstall.sh is not readable
205 fi
[3aa1acd]206 fi
207 ;;
[8825e69]208 # Display non-validated envars found in lfs_PARAM_LIST
[350625a]209 * ) echo -e "`eval echo $PARAM_VALS`" ;;
210
[45f82718]211 esac
212 done
[4965fa8]213
214 if [[ "${BLFS_TOOL}" = "y" ]] ; then
215 echo "${nl_} ${BLUE}blfs-tool settings${OFF}"
216 for config_param in ${blfs_tool_PARAM_LIST}; do
217 echo -e "`eval echo $PARAM_VALS`"
218 done
219 fi
220
[53f291f]221 if [[ "${CUSTOM_TOOLS}" = "y" ]] && [[ "${BLFS_TOOL}" = "n" ]] ; then
222 for config_param in ${custom_tool_PARAM_LIST}; do
223 echo -e "`eval echo $PARAM_VALS`"
224 done
225 fi
226
[877cc6a]227 set -e
[21f0a91]228 echo "${nl_}***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***${nl_}"
[877cc6a]229}
Note: See TracBrowser for help on using the repository browser.